'From Squeak3.2gamma of 15 January 2002 [latest update: #4743] on 20 February 2002 at 1:29:48 am'!
EventManager subclass: #AbstractDispatchQueue
	instanceVariableNames: 'queue stepper state '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Queues-Dispatch'!

!AbstractDispatchQueue commentStamp: '<historical>' prior: 0!
"Test code"

	| queue |
	queue := DispatchQueue new.
	queue foreground.
	[10 timesRepeat: [queue asyncSend: #value to: [Smalltalk beep]]] fork.
	queue

	queue when: #event send: #beep to: Smalltalk.
	queue when: #dispatchQueueClosed send: #value to: [queue release. Transcript cr; show: 'queue closed event'].
	queue enqueue: [queue triggerEvent: #event].
(Delay forMilliseconds: 10) wait.
	queue close.


Smalltalk garbageCollect.
DispatchQueue withAllSubclasses asOrderedCollection collect: [:each | each instanceCount].

DispatchQueue withAllSubclassesDo: 
	[:eachClass | eachClass allInstancesDo: 
		[:eachInst | eachInst inspect]].




Smalltalk garbageCollect


{QueuedFuture allInstances. DispatchQueue allInstances. DispatchQueueTest allInstances. AsyncMessageSecretary allInstances. EventTupleSpace allInstances} 
	inject: false 
	into: [:stillGarbage :eachColl | stillGarbage | eachColl isEmpty not]


QueuedFuture allInstances do: [:e | e release].
((DispatchQueue allInstances select: [:e | e isForeground])
	select: [:each | each queue isKindOf: SharedQueue]) do: [:q | q close].
((DispatchQueue allInstances select: [:e | e isBackground])
	select: [:each | each queue isKindOf: SharedQueue]) do: [:q | q close].
!
]style[(658 85 17 15 21 133 14 36 2 26 107 26 105)f1,f1c142040000,f1,f1c142040000,f1,f1c142040000,f1,f1c142040000,f1,f1c142040000,f1,f1c142040000,f1!

Object subclass: #AsyncMessageSecretary
	instanceVariableNames: 'queue '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Async'!

!AsyncMessageSecretary commentStamp: '<historical>' prior: 0!
| a1 a2 |
a1 := AsyncMessageSecretary new.
a2 := AsyncMessageSecretary new.
a1 foreground.
a2 background.

a1 
	asyncSend: #value 
	to: [ Transcript cr; show: 'hello']  
	agent: a2 
	onResult: [:r | Smalltalk beep] 
	ifError:  [:err |  Smalltalk beep].
[	(Delay forSeconds: 1) wait.
	a1 close.
	a2 close] fork.!

AbstractDispatchQueue subclass: #DispatchQueue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Queues-Dispatch'!
Object subclass: #Future
	instanceVariableNames: 'result resultSemaphore '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Futures'!
Future class
	instanceVariableNames: ''!
DispatchQueue subclass: #FutureDispatchQueue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Queues-Dispatch'!
Error subclass: #FutureInterrupted
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Futures'!
Error subclass: #FutureNoResult
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Futures'!
Error subclass: #FutureTimeout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Futures'!
Object subclass: #QueuedFuture
	instanceVariableNames: 'myEvents dispatchQ '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Async'!
Object subclass: #Task
	instanceVariableNames: 'process taskAction shouldRescheduleAction stopping stopSemaphore priority '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Tasks'!

!Task commentStamp: '<historical>' prior: 0!
This class models an activity. This activity is presumed to occur some number of milliseconds in the future. In addition, it may be a recurring task. The task is created in a dormant state. The message #start must be sent to an instance before it will schedule itself for execution. At any point, one may deschedule a task by sending the message #stop.!

Task class
	instanceVariableNames: ''!

!Object methodsFor: 'async sending' stamp: 'rw 2/17/2002 02:13'!
asyncSendMessage: aMessage future: aFuture 
	self secretary 
		sendMessage: aMessage
		to: self
		future: aFuture
! !


!AbstractDispatchQueue methodsFor: 'testing' stamp: 'rw 2/16/2002 15:43'!
isBackground
	^ state = self backgroundState! !

!AbstractDispatchQueue methodsFor: 'testing' stamp: 'rw 2/20/2002 01:23'!
isEmpty

	^ queue isEmpty! !

!AbstractDispatchQueue methodsFor: 'testing' stamp: 'rw 2/16/2002 15:43'!
isForeground
	^ state = self foregroundState! !

!AbstractDispatchQueue methodsFor: 'testing' stamp: 'rw 2/16/2002 15:44'!
isRunning
	^ state ~= self suspendedState! !

!AbstractDispatchQueue methodsFor: 'testing' stamp: 'rw 2/20/2002 01:23'!
notEmpty

	^ self isEmpty not! !

!AbstractDispatchQueue methodsFor: 'testing' stamp: 'rw 2/16/2002 18:56'!
size

	^ queue isNil
		ifTrue: [0]
		ifFalse: [queue size]
! !

!AbstractDispatchQueue methodsFor: 'accessing' stamp: 'rw 2/16/2002 18:48'!
nextPut: anItem

	queue nextPut: anItem
! !

!AbstractDispatchQueue methodsFor: 'accessing' stamp: 'rw 2/20/2002 01:24'!
priority

	^stepper 
		ifNil: [-1] 
		ifNotNil: [stepper priority].! !

!AbstractDispatchQueue methodsFor: 'accessing' stamp: 'rw 2/20/2002 01:24'!
priority: aPriority

	stepper ifNotNil: [stepper priority: aPriority].
! !

!AbstractDispatchQueue methodsFor: 'private' stamp: 'rw 2/16/2002 18:56'!
backgroundState

	^#background! !

!AbstractDispatchQueue methodsFor: 'private' stamp: 'rw 2/16/2002 18:47'!
dispatch
	| item |
	item _ queue nextTimeoutMSecs: 100.
	item value! !

!AbstractDispatchQueue methodsFor: 'private' stamp: 'rw 2/16/2002 18:56'!
foregroundState

	^#foreground! !

!AbstractDispatchQueue methodsFor: 'private' stamp: 'rw 2/16/2002 18:55'!
initialize

	state := self suspendedState.! !

!AbstractDispatchQueue methodsFor: 'private' stamp: 'rw 2/20/2002 01:24'!
printOn: aStream 

	super printOn: aStream.
	aStream nextPutAll: ' ('.
	aStream nextPutAll: ' pending: ' , self size printString.
	aStream nextPutAll: ' priority: ', self priority printString. 
	aStream nextPutAll: ')'! !

!AbstractDispatchQueue methodsFor: 'private' stamp: 'rw 2/16/2002 18:55'!
suspendedState

	^#suspended! !

!AbstractDispatchQueue methodsFor: 'control' stamp: 'rw 2/16/2002 18:51'!
background
	self suspend.
	state := self backgroundState.
	queue := SharedQueue new.
	stepper _ Task taskAction: (MessageSend receiver: self selector: #dispatch).
	stepper start.
! !

!AbstractDispatchQueue methodsFor: 'control' stamp: 'rw 2/16/2002 18:51'!
close
	"We need to do this after all events have been flushed, so:  
	
		stop enqueuing  
	
		when the last event has been processed, suspend the stepper"

	self flush.
	self suspend.! !

!AbstractDispatchQueue methodsFor: 'control' stamp: 'rw 2/16/2002 18:51'!
flush

	[self isEmpty not] whileTrue: [queue nextNoWait].
! !

!AbstractDispatchQueue methodsFor: 'control' stamp: 'rw 2/16/2002 18:51'!
foreground
	| oldQueue |
	self suspend.
	state := self foregroundState.
	oldQueue := queue.
	queue := WorldState deferredUIMessages.
	oldQueue isNil ifFalse: [[oldQueue isEmpty] whileFalse: [queue nextPut: oldQueue nextOrNil]].! !

!AbstractDispatchQueue methodsFor: 'control' stamp: 'rw 2/16/2002 18:51'!
suspend

	| theStepper |
	state := self suspendedState.
	stepper ifNotNil: 
		[theStepper := stepper.
		stepper := nil.
		theStepper stop].

! !


!AsyncMessageSecretary methodsFor: 'accessing' stamp: 'rww 1/15/2001 05:44'!
priority

	^queue priority.! !

!AsyncMessageSecretary methodsFor: 'accessing' stamp: 'rww 1/15/2001 05:44'!
priority: aPriority

	^queue priority: aPriority.! !

!AsyncMessageSecretary methodsFor: 'control' stamp: 'rww 1/5/2001 06:46'!
background

	queue background.
! !

!AsyncMessageSecretary methodsFor: 'control' stamp: 'rww 9/26/2001 09:53'!
close
	queue close.
	self releaseActionMap.! !

!AsyncMessageSecretary methodsFor: 'control' stamp: 'rww 1/5/2001 06:46'!
foreground

	queue foreground.
! !

!AsyncMessageSecretary methodsFor: 'control' stamp: 'rww 1/5/2001 06:46'!
suspend

	queue suspend.
! !

!AsyncMessageSecretary methodsFor: 'futures' stamp: 'rww 7/8/2001 21:06'!
createFuture

	^ QueuedFuture onQueue: queue.
! !

!AsyncMessageSecretary methodsFor: 'initialization' stamp: 'rw 2/17/2002 00:02'!
initialize
	queue _ AbstractDispatchQueue new! !

!AsyncMessageSecretary methodsFor: 'initialization' stamp: 'rww 1/15/2001 05:53'!
printOn: aStream 

	super printOn: aStream.
	aStream nextPutAll: ' ('.
	aStream nextPutAll: ' pending: ' , queue size printString.
	aStream nextPutAll: ' priority: ', self priority printString. 
	aStream nextPutAll: ')'! !

!AsyncMessageSecretary methodsFor: 'sending' stamp: 'rw 2/16/2002 23:55'!
sendMessage: aMessage to: target future: future

	| msgSend |
	msgSend := [[future value: (target 
		perform: aMessage selector 
		withArguments: aMessage arguments)]
			on: Exception
			do: [:ex | future exception: ex]].
	queue nextPut: msgSend.
	^ future
! !


!AsyncMessageSecretary class methodsFor: 'instance creation' stamp: 'rww 1/14/2001 02:19'!
dispatchBackground

	^self new 
		background;
		yourself.


! !

!AsyncMessageSecretary class methodsFor: 'instance creation' stamp: 'rww 1/14/2001 02:19'!
dispatchForeground

	^self new 
		foreground;
		yourself.


! !

!AsyncMessageSecretary class methodsFor: 'instance creation' stamp: 'rww 1/14/2001 02:19'!
new

	^super new initialize

! !


!DispatchQueue methodsFor: 'event api' stamp: 'rw 2/16/2002 15:14'!
asyncTriggerEvent: anEventSelector to: aEventSource 
	self
		asyncTriggerEvent: anEventSelector
		to: aEventSource
		withArguments: #()! !

!DispatchQueue methodsFor: 'event api' stamp: 'rw 2/16/2002 15:14'!
asyncTriggerEvent: anEventSelector to: aEventSource ifNotHandled: aBlock 
	self
		asyncTriggerEvent: anEventSelector
		to: aEventSource
		withArguments: #()
		ifNotHandled: aBlock! !

!DispatchQueue methodsFor: 'event api' stamp: 'rw 2/16/2002 18:34'!
asyncTriggerEvent: anEventSelector to: aEventSource with: arg1 
	self
		asyncTriggerEvent: anEventSelector
		to: aEventSource
		withArguments: (Array with: arg1)
		ifNotHandled: []! !

!DispatchQueue methodsFor: 'event api' stamp: 'rw 2/16/2002 15:14'!
asyncTriggerEvent: anEventSelector to: aEventSource with: arg1 ifNotHandled: aBlock 
	self
		asyncTriggerEvent: anEventSelector
		to: aEventSource
		withArguments: (Array with: arg1)
		ifNotHandled: aBlock! !

!DispatchQueue methodsFor: 'event api' stamp: 'rw 2/16/2002 15:14'!
asyncTriggerEvent: anEventSelector to: aEventSource with: arg1 with: arg2 
	self
		asyncTriggerEvent: anEventSelector
		to: aEventSource
		withArguments: (Array with: arg1 with: arg2)! !

!DispatchQueue methodsFor: 'event api' stamp: 'rw 2/16/2002 15:13'!
asyncTriggerEvent: anEventSelector to: aEventSource with: arg1 with: arg2 ifNotHandled: aBlock 
	self
		asyncTriggerEvent: anEventSelector
		to: aEventSource
		withArguments: (Array with: arg1 with: arg2)
		ifNotHandled: aBlock! !

!DispatchQueue methodsFor: 'event api' stamp: 'rw 2/16/2002 15:13'!
asyncTriggerEvent: anEventSelector to: aEventSource withArguments: arrayOfArguments 
	self
		asyncTriggerEvent: anEventSelector
		to: aEventSource
		withArguments: arrayOfArguments
		ifNotHandled: []! !

!DispatchQueue methodsFor: 'event api' stamp: 'rw 2/16/2002 15:13'!
asyncTriggerEvent: anEventSelector to: aEventSource withArguments: arrayOfArguments ifNotHandled: aBlock 
	self
		asyncSend: #triggerEvent:withArguments:ifNotHandled:
		to: aEventSource
		withArguments: (Array
				with: anEventSelector
				with: arrayOfArguments
				with: aBlock)! !

!DispatchQueue methodsFor: 'send api' stamp: 'rw 2/20/2002 00:56'!
asyncSend: aSelector to: aReceiver 
	self
		nextPut: (self messageSendClass receiver: aReceiver selector: aSelector)! !

!DispatchQueue methodsFor: 'send api' stamp: 'rw 2/16/2002 15:14'!
asyncSend: aSelector to: aReceiver with: arg1 
	self
		asyncSend: aSelector
		to: aReceiver
		withArguments: (Array with: arg1)! !

!DispatchQueue methodsFor: 'send api' stamp: 'rw 2/16/2002 15:14'!
asyncSend: aSelector to: aReceiver with: arg1 with: arg2 
	self
		asyncSend: aSelector
		to: aReceiver
		withArguments: (Array with: arg1 with: arg2)! !

!DispatchQueue methodsFor: 'send api' stamp: 'rw 2/20/2002 00:56'!
asyncSend: aSelector to: aReceiver withArguments: argArray 
	self
		nextPut: (self messageSendClass
				receiver: aReceiver
				selector: aSelector
				arguments: argArray)! !

!DispatchQueue methodsFor: 'events' stamp: 'rw 2/16/2002 15:15'!
triggerEvent: anEventSelector withArguments: arrayOfArguments ifNotHandled: aBlock 
	(self hasActionForEvent: anEventSelector)
		ifFalse: [[^ aBlock value]
				on: Exception
				do: [:ex | 
					super triggerEvent: #dispatchError with: ex.
					ex return]].
	[(self actionForEvent: anEventSelector)
		valueWithArguments: arrayOfArguments]
		on: Exception
		do: [:ex | 
			super triggerEvent: #dispatchError with: ex.
			ex return]! !

!DispatchQueue methodsFor: 'private' stamp: 'rw 2/16/2002 18:43'!
messageSendClass

	^MessageSend! !


!Future methodsFor: 'initialization' stamp: 'rww 7/8/2001 18:22'!
initialize

	resultSemaphore := Semaphore new.
! !

!Future methodsFor: 'consumer' stamp: 'rw 2/10/2002 17:04'!
value
	resultSemaphore wait.
	^ result notNil
		ifTrue: ["So others can get the value"
			resultSemaphore signal.
			result value]
		ifFalse: [self signalNoResult]!
]style[(5 2 15 35 29 4 15 12 6 20 4 16)f1b,f1,f1cmagenta;,f1,f1c140038000,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1! !

!Future methodsFor: 'consumer' stamp: 'rw 2/10/2002 17:04'!
valueTimeoutMSecs: millis 
	resultSemaphore waitTimeoutMSecs: millis.
	^ result notNil
		ifTrue: ["So others can get the value"
			resultSemaphore signal.
			result value]
		ifFalse: [self signalTimeout]! !

!Future methodsFor: 'consumer' stamp: 'rw 2/11/2002 23:55'!
whenResolved: aValueResolver onException: anExceptionResolver

	self when: #value: asend: #value: to: aValueResolver.
	self when: #exception: asend: #value: to: anExceptionResolver.
! !

!Future methodsFor: 'control' stamp: 'rww 7/8/2001 18:20'!
interrupt

	result := [self signalInterrupt] fixTemps.
	resultSemaphore signal.! !

!Future methodsFor: 'producer' stamp: 'rw 2/11/2002 23:49'!
exception: anException

	result := [anException signal] fixTemps.
	resultSemaphore signal.

	self 
		triggerEvent: #value:
		with: result.
! !

!Future methodsFor: 'producer' stamp: 'rw 2/11/2002 23:49'!
value: value

	result := value.
	resultSemaphore signal.
	self 
		triggerEvent: #value:
		with: result.
! !

!Future methodsFor: 'exceptions' stamp: 'rww 12/16/2000 13:36'!
signalInterrupt

	^ FutureInterrupted signal: 'future interrupted'
! !

!Future methodsFor: 'exceptions' stamp: 'rww 12/16/2000 15:18'!
signalNoResult

	^FutureNoResult signal: 'no result yet'
! !

!Future methodsFor: 'exceptions' stamp: 'rww 12/16/2000 13:35'!
signalTimeout

	^FutureTimeout signal: 'future timed out'
! !


!Future class methodsFor: 'instance creation' stamp: 'rww 12/15/2000 21:23'!
new

	^ super new initialize
! !


!FutureDispatchQueue methodsFor: 'private' stamp: 'rw 2/20/2002 00:55'!
asyncSend: aSelector to: aReceiver future: aFuture 
	self
		asyncSendMessage: (self messageSendClass receiver: aReceiver selector: aSelector)
		future: aFuture! !

!FutureDispatchQueue methodsFor: 'private' stamp: 'rw 2/20/2002 00:55'!
asyncSend: aSelector to: aReceiver with: arg1 future: aFuture 
	self
		asyncSend: aSelector
		to: aReceiver
		withArguments: (Array with: arg1)
		future: aFuture! !

!FutureDispatchQueue methodsFor: 'private' stamp: 'rw 2/20/2002 00:55'!
asyncSend: aSelector to: aReceiver with: arg1 with: arg2 future: aFuture 
	self
		asyncSend: aSelector
		to: aReceiver
		withArguments: (Array with: arg1 with: arg2)
		future: aFuture! !

!FutureDispatchQueue methodsFor: 'private' stamp: 'rw 2/20/2002 00:55'!
asyncSend: aSelector to: aReceiver withArguments: argArray future: aFuture 
	self
		asyncSendMessage: (self messageSendClass
				receiver: aReceiver
				selector: aSelector
				arguments: argArray)
		future: aFuture! !

!FutureDispatchQueue methodsFor: 'private' stamp: 'rw 2/20/2002 00:56'!
asyncSendMessage: aMessageSend future: aFuture 
	self
		nextPut: (self messageSendClass
				receiver: self
				selector: #dispatchMessage:future:
				arguments: (Array with: aMessageSend with: aFuture))! !

!FutureDispatchQueue methodsFor: 'private' stamp: 'rw 2/20/2002 00:55'!
dispatchMessage: aMsg future: aFuture 
	| result |
	[result _ aMsg value.
	aFuture value: result]
		on: Exception
		do: [:ex | aFuture exception: ex]! !


!QueuedFuture methodsFor: 'initialization' stamp: 'rw 2/17/2002 02:26'!
actionMap

    ^myEvents == nil
        ifTrue: [self createActionMap]
        ifFalse: [myEvents]! !

!QueuedFuture methodsFor: 'initialization' stamp: 'rww 1/14/2001 02:14'!
bindQueue: aQueue

	dispatchQ := aQueue.

! !

!QueuedFuture methodsFor: 'initialization' stamp: 'rw 2/17/2002 02:27'!
copy

	| answer |
	answer := super copy.
	answer release.
	^answer! !

!QueuedFuture methodsFor: 'initialization' stamp: 'rw 2/17/2002 02:26'!
releaseActionMap

    myEvents := nil! !

!QueuedFuture methodsFor: 'initialization' stamp: 'rw 2/17/2002 02:27'!
updateableActionMap

    myEvents == nil
        ifTrue: [myEvents := self createActionMap].
    ^myEvents! !

!QueuedFuture methodsFor: 'producer' stamp: 'rw 2/17/2002 00:12'!
exception: anException

	| msgSend |
	msgSend := [[self triggerEvent: #exception: with: anException]
		on: Exception
		do: [:ex | ]].
	dispatchQ nextPut: msgSend.
! !

!QueuedFuture methodsFor: 'producer' stamp: 'rw 2/17/2002 00:10'!
value: aValue

	| msgSend |
	msgSend := [[self triggerEvent: #result: with: aValue]
		on: Exception
		do: [:ex | ]].
	dispatchQ nextPut: msgSend.
! !

!QueuedFuture methodsFor: 'accessing' stamp: 'rw 2/17/2002 02:25'!
myEvents

	^myEvents! !

!QueuedFuture methodsFor: 'accessing' stamp: 'rw 2/17/2002 02:25'!
myEvents: events

	myEvents := events! !


!QueuedFuture class methodsFor: 'instance creation' stamp: 'rww 7/8/2001 21:29'!
new

	self shouldNotImplement! !

!QueuedFuture class methodsFor: 'instance creation' stamp: 'rww 7/8/2001 21:29'!
onQueue: aQueue

	^ self basicNew
		bindQueue: aQueue;
		yourself
! !


!SharedQueue methodsFor: 'accessing' stamp: 'rww 1/13/2002 12:45'!
flush
	"Throw out all pending contents"
	accessProtect critical: [
		readPosition _ 1.
		writePosition _ 1.
		readPosition >= writePosition ifTrue: [readSynch initSignals].
		contentsArray 
			from: writePosition
			to: contentsArray size 
			put: nil].! !

!SharedQueue methodsFor: 'accessing' stamp: 'rww 8/26/2001 23:44'!
nextNoWait
	"Answer the object that was sent through the  
	
	receiver first and has not  
	
	yet been received by anyone. If no object has  
	
	been sent, return nil."
	^ self nextOrNil! !

!SharedQueue methodsFor: 'accessing' stamp: 'rww 1/13/2002 12:47'!
nextTimeoutMSecs: milliSeconds 
	"Answer the object that was sent through the  
	receiver first and has not  
	yet been received by anyone. If no object has 
	been sent, suspend the  
	requesting process until one is."

	| value |
	readSynch waitTimeoutMSecs: milliSeconds.
	accessProtect
		critical: 
			[readPosition = writePosition
				ifTrue: 
					[value := nil]
				ifFalse: 
					[value := contentsArray at: readPosition.
					contentsArray at: readPosition put: nil.
					readPosition := readPosition + 1]].
	^ value! !

!SharedQueue methodsFor: 'accessing' stamp: 'rww 1/13/2002 12:49'!
peek
	"Answer the object that was sent through the receiver first and has not 
	yet been received by anyone but do not remove it from the receiver. If 
	no object has been sent, suspend the requesting process until one is."

	| value |
	accessProtect
		critical: 
			[readPosition >= writePosition
				ifTrue: 
					[readPosition _ 1.
					writePosition _ 1.
					value _ nil]
				ifFalse: 
					[value _ contentsArray at: readPosition].
			readPosition >= writePosition ifTrue: [readSynch initSignals]].
	^value! !

!SharedQueue methodsFor: 'private' stamp: 'rww 1/13/2002 12:49'!
makeRoomAtEnd
	| contentsSize |
	readPosition = 1
		ifTrue: 
			[contentsArray _ contentsArray , (Array new: 10)]
		ifFalse: 
			[contentsSize _ writePosition - readPosition.

			contentsArray
				replaceFrom: 1
				to: contentsSize
				with: contentsArray
				startingAt: readPosition.
			readPosition _ 1.
			writePosition _ contentsSize + 1.
			contentsArray 
				from: writePosition
				to: contentsArray size 
				put: nil]! !


!Task methodsFor: 'accessing' stamp: 'rw 2/16/2002 15:06'!
priority

	^

process
		ifNil: [-1]
		ifNotNil: [process priority].
! !

!Task methodsFor: 'accessing' stamp: 'rw 2/16/2002 15:11'!
priority: aPriority

	(self isValidPriority: aPriority)
		ifFalse: [^self].

	process ifNotNil: 
		[process priority: aPriority].
! !

!Task methodsFor: 'accessing' stamp: 'slosh 11/19/2000 21:37'!
shouldRescheduleAction 

	^stopping 
		ifTrue: [false]
		ifFalse: [shouldRescheduleAction]! !

!Task methodsFor: 'accessing' stamp: 'rww 9/8/2000 12:35'!
shouldRescheduleAction: anEvaluableAction

	shouldRescheduleAction := anEvaluableAction! !

!Task methodsFor: 'accessing' stamp: 'rww 9/8/2000 12:34'!
taskAction

	^taskAction ! !

!Task methodsFor: 'accessing' stamp: 'rww 9/8/2000 12:36'!
taskAction: anEvaluableAction

	taskAction := anEvaluableAction! !

!Task methodsFor: 'scheduling' stamp: 'slosh 11/19/2000 21:32'!
isValidPriority: aPriority

	^ aPriority between: Processor systemBackgroundPriority and: Processor timingPriority 
! !

!Task methodsFor: 'scheduling' stamp: 'rw 2/16/2002 15:12'!
restart
	| myPriority |
	myPriority := self priority.
	self stop.
	self start.
	self priority: myPriority.


! !

!Task methodsFor: 'scheduling' stamp: 'rw 2/10/2002 17:02'!
schedule

	[self taskAction value.
	self shouldRescheduleAction value]
		whileTrue.
	stopSemaphore signal.
	process := nil.
! !

!Task methodsFor: 'scheduling' stamp: 'rw 2/16/2002 15:11'!
start

	process == nil ifFalse: [self error: 'Process has already been scheduled.'].
	stopping := false.
	stopSemaphore := Semaphore new.
	process := [self schedule] forkAt: Processor userInterruptPriority.
! !

!Task methodsFor: 'scheduling' stamp: 'rww 1/13/2002 22:40'!
stop

	process ifNil: [^self].
	stopping := true.
	stopSemaphore waitTimeoutMSecs: 1.
	process ifNotNil: 
		[process terminate.
		process := nil].! !


!Task class methodsFor: 'instance creation' stamp: 'rw 2/16/2002 18:59'!
taskAction: aTaskAction

	^self 
		taskAction: aTaskAction
		shouldRescheduleAction: true
! !

!Task class methodsFor: 'instance creation' stamp: 'rw 2/16/2002 15:09'!
taskAction: aTaskAction
shouldRescheduleAction: aBooleanAction

	^self new
		taskAction: aTaskAction;
		shouldRescheduleAction: aBooleanAction;
		yourself! !


!QueuedFuture reorganize!
('initialization' actionMap bindQueue: copy releaseActionMap updateableActionMap)
('producer' exception: value:)
('accessing' myEvents myEvents:)
!


!Future reorganize!
('initialization' initialize)
('consumer' value valueTimeoutMSecs: whenResolved:onException:)
('control' interrupt)
('producer' exception: value:)
('exceptions' signalInterrupt signalNoResult signalTimeout)
!


!AsyncMessageSecretary reorganize!
('accessing' priority priority:)
('control' background close foreground suspend)
('futures' createFuture)
('initialization' initialize printOn:)
('sending' sendMessage:to:future:)
!

